// PlayerCoordinator.cpp: implementation of the CPlayerCoordinator class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "player.h"
#include "PlayerCoordinator.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CPlayerCoordinator::CPlayerCoordinator() : CCoordinator(2)
{
    int sp_simulatorstep;

    m_pSystemClock = new CSystemClock;
    m_pSystemClock->Initialize();

    sp_simulatorstep = 100.0;
    // if (cfgval=getconfig(sp_simulatorstep)) sp_simulatorstep = cfgval;

    m_pServerConnection = new CServerConnection(m_cThreadVector[0], this, m_pSystemClock);
    m_pServerMsgTranslator = new CServerMsgTranslator(m_cThreadVector[0], this);
    m_pServerCommunicator = new CServerCommunicator(m_cThreadVector[0], this, sp_simulatorstep, m_pSystemClock);

    m_pSoccerAgent = new CSoccerAgent(m_cThreadVector[1], this);

    PostEvent(new CConnectEvent("localhost", 6000));
    PostEvent(new CSendEvent("(init motkovia)"));
}

CPlayerCoordinator::~CPlayerCoordinator()
{
    PostEvent(new CSendEvent("(bye)"));
    PostEvent(new CBasicEvent(ET__SRVDISCONNECT, true));

    Sleep(1000);

    delete m_pSoccerAgent;

    delete m_pServerCommunicator;
    delete m_pServerMsgTranslator;
    delete m_pServerConnection;
    delete m_pSystemClock;
}
