#ifndef SERVERCOMMUNICATOR_H
#define SERVERCOMMUNICATOR_H

#include "SystemClock.h"
#include "GameState.h"
#include "EventRecipient.h"
#include "Perception.h"
#include "GameCommand.h"

// #define BLIND_TIME_COUNT       // ci pocitat hraci cas podla narastania
                                  //   systemoveho casu (mimo stop modov)
// #define SENSEBODY_STOPTIME_COUNT   // ci pocas stop modov pocitat stopcycles
                                      //   podla poctu sprav sense_body

class CServerCommunicator: public CEventRecipient
{
protected:
    int m__SP_SIMULATOR_STEP;            // server parameter:  send_step

protected:
    int m_nLastDeliberateTime;
    int m_nLastSendTime;

private:
    bool m_bSynchronized;
    int  m_nSynchPlayTime;
    TSystemTime m_tSynchSystemTime;
    TSystemTime m_tLastSystemTime;

protected:
    CGameState m_cGameState;             // aktualny stav hry
    CPerceptionSeq *m_pPerceptionSeq;    // postupnost prijatych vnemov
    CGameCommandSeq *m_pSentCommandSeq;  // postupnost odoslanych povelov

protected:
    CSystemClock *m_pSystemClock;

public:
	CServerCommunicator(CWinThread* pDefThread, CCoordinator* pCoordinator, int SP_SIMULATOR_STEP, CSystemClock *pSystemClock);
    virtual ~CServerCommunicator();

	virtual void OnEvent(CBasicEvent *pEvent);

    void OnSynchTimer(int nTimeToNextCall = 0);

    int UpdateGameTime(TSystemTime tSystemTime);
    void UpdateSynchTime(int nPlayTime, TSystemTime tSystemTime);
    void UpdateGameState(CPerception *pPerception);
    void ProcessReceivedSrvMsg(CPerception *pPerception);

/*
private:
    int nLastDeliberateTime;
    int nLastSendTime;

private:
    Bool m_bSynchronized;
    int m_nSynchPlayTime;
    int m_nSynchSystemTime;
    int m_nLastSystemTime;

public:
    void Initialize(CGameState *pGameState,
                    CPerceptionSeq *pPerceptionSeq,
                    CSystemClock *pSysClock,
                    CServerConnection *pSrvConnection,
                    CServerMsgTranslator *pSrvTranslator);

	void OnReceiveServerMsg();
	void OnSynchTimer(int nTimeToNextCall = 0);

    int UpdateGameTime(int nSystemTime);
    void UpdateSynchTime(int nPlayTime, int nSystemTime);
    void UpdateGameState(CPerception *pPerception);

//    void ProcessReceivedSrvMsgs();
    void SendCommands(CGameCommandSeq *pSendCommands);
*/
};

#endif  // SERVERCOMMUNICATOR_H
