#include "stdafx.h"
#include "SoccerAgent.h"

CSoccerAgent::CSoccerAgent(CWinThread* pDefThread, CCoordinator* pCoordinator) :
    CEventRecipient(pDefThread, pCoordinator)
{
    RegisterEvent(ET__DELIBERATE);
    // +eventy od vizualizatora
}

CSoccerAgent::~CSoccerAgent()
{
    UnregisterEvent(ET__DELIBERATE);
}

void CSoccerAgent::OnEvent(CBasicEvent *pEvent)
{
    TRACE("OnEvent: %d\n", pEvent->m_eEventType);

    switch (pEvent->m_eEventType)
    {
    case ET__DELIBERATE:
        CGameState cGameState;
        CPerceptionSeq *pPerceptionSeq;
        CGameCommandSeq *pSentCommangsSeq, *pActCommands;

        cGameState = ((CDeliberateEvent*) pEvent)->m_cGameState;
        pPerceptionSeq = ((CDeliberateEvent*) pEvent)->m_pPerceptionSeq;
        pSentCommangsSeq = ((CDeliberateEvent*) pEvent)->m_pSentCommandSeq;
        
        pActCommands = new CGameCommandSeq;
        m_cLocalAgent.Deliberate(cGameState, pPerceptionSeq, pSentCommangsSeq, pActCommands);
        PostEvent(new CActEvent(pActCommands));
        //delete pSentCommangsSeq;
        break;
    }

    pEvent->Release();
}
